import pyblog
import urllib
import os
import re
import base64
#import sys
import xmlrpclib
import logging
from google.appengine.ext import webapp
from google.appengine.ext.webapp.mail_handlers import InboundMailHandler
from google.appengine.api import mail
#from poster.encode import MultipartParam, multipart_encode
#from google.appengine.ext import db
#from google.appengine.ext import ereporter
from google.appengine.api import urlfetch

#ereporter.register_logger()

class MyException(Exception):
    pass
    
class PostToUrl(InboundMailHandler):
    def recipients_as_string(self, mail_message_field):
        if not mail_message_field:
            return None
        return mail_message_field if isinstance(mail_message_field, basestring) else ','.join(mail_message_field)

    def get_body_parts(self, mail_message, mime_type):
        body_parts = []
        for _, payload in mail_message.bodies(mime_type):
            # FIXME(andi): Remove this when issue 2383 is fixed.
            # 8bit encoding results in UnknownEncodingError, see
            # http://code.google.com/p/googleappengine/issues/detail?id=2383
            # As a workaround we try to decode the payload ourselves.
            if payload.encoding == '8bit' and payload.charset:
                body_parts.append(payload.payload.decode(payload.charset))
            else:
                body_parts.append(payload.decode())
        return body_parts

    def receive(self, mail_message):
        try:
            result=self.post_comment(mail_message)
        except MyException as e:
            result=e.message
        logging.debug(result)
        if result!="OK":
            body=''.join(self.get_body_parts(mail_message, 'text/plain'))
            self.send_notification(
                mail_message.original.get('message-id', None),
                mail_message.sender, 
                self.recipients_as_string(mail_message.to), 
                "mail@antoniorinaldi.it", 
                mail_message.subject, 
                result, body)
        
    def post_comment(self,msg):
        try:
            complete_message = msg.original
            sender = msg.sender
            to = self.recipients_as_string(msg.to) if hasattr(msg, 'to') else None
            cc = self.recipients_as_string(msg.cc) if hasattr(msg, 'cc') else None
            message_id = complete_message.get('message-id', None)
            subject = msg.subject if hasattr(msg, 'subject') else ''
            body = ''.join(self.get_body_parts(msg, 'text/plain'))
            notifyto=sender
            pass
        except: 
            raise MyException("Unable to initialize message variables")

        try:
            reply = re.search("([\S\s]*)\n.*?!END", body)
            comment_text=reply.group(1)
        except: 
            raise MyException("Unable to find reply delimiter")
        
        try:
            #logging.debug(to)
            to_pars=re.search("\+(.*)@", to)
            #logging.debug(to_pars.group(1))
            logging.debug(base64.b64decode(to_pars.group(1)))
            dec_pars=re.search("(.*)?:(.*)?:(.*)",base64.b64decode(to_pars.group(1)))
            authorID=dec_pars.group(1)
            postID=dec_pars.group(2)
            commentID=dec_pars.group(3)
        except: 
            raise MyException("Unable to decode addressee parameters")
                
        try:
            blog = pyblog.WordPress(os.environ.get("XMLRPC_URL"), os.environ.get("USERNAME"), os.environ.get("PASSWORD"))
            if os.environ.get("SAFE"):
                notifyto=os.environ.get("COPY_EMAIL_TO")
                cs={
                    "comment_parent":commentID,
                    "content":comment_text,
                    "author":os.environ.get("AUTHOR"),
                    "author_url":os.environ.get("URL"),
                    "author_email":os.environ.get("EMAIL")
                }
            else:
                us=blog.get_user(authorID)
                notifyto=us["email"]
                cs={
                    "comment_parent":commentID,
                    "content":comment_text,
                    "author":us["display_name"],
                    "author_url":us["url"],
                    "author_email":us["email"]
                }
        except: 
            raise MyException("Unable to retrieve blog information")
            
        try:
            #print cs
            #print postID
            comm=""
            comm = blog.new_comment(postID,cs)
            #print comm
        except:
            raise MyException("unable to post comment " + str(comm))
        self.send_notification(message_id, sender, to, notifyto, subject, "OK: Post #"+ str(comm) + " inserted.\n", comment_text)
        return "OK"
         
    def send_notification(self, message_id, original_sender, original_to, to, original_subject, outcome, original_body):
        sender = os.environ.get('COPY_EMAIL_FROM')
        subject = os.environ.get('COPY_EMAIL_SUBJECT')
        body = '%s\n--\n\nMessage Id=%s\nSender=%s\nTo=%s\nSubject=%s\n\n%s' % (
        outcome, message_id, original_sender, original_to, original_subject, original_body)
        mail.send_mail(sender=sender,
            to=to,
            subject=subject,
            body=body)

app = webapp.WSGIApplication([PostToUrl.mapping()], debug=True)
